#include <PS2Keyboard.h>
#include <LiquidCrystal.h>
/*
Ardumors
========
by Markus Klingler 21.04.2014

written for arduino micro, other boards not testet
+++++Attention! this sketch needs the PS2Keyboard libary!+++++

please excuse my bad english
I'll improve it soon
 
to use it conect
  an ps2-keyboard to 
 Ardu-Pin       Device-Pin
 ========       ==========
    8       -   Data
    3 or 5? -   Clock
    5V      -   VCC
    GND     -   GND    
 a lcd display to
    12      -   rs(4)
    11      -   e(6)
    7       -   d4(11) 
    6       -   d5(12)
    5       -   d6(13)
    4       -   d7(14)
    10      -   backlight+(15)
    GND     -   backlight-(16)
    GND     -   rw(5)
    5V      -   VCC
    GND     -   GND
    trimmer -   V0(3) 
 a LED or buzzer
    2       -   +
    GND     -   -

++ usage: ++
============
swich on circuit and wait for 5 seconds
now you can begin to type.
press ENTER to send
you can press ESC to aport transmision

to go to the menu press arrow up
select menuenty with arrow up and arrow down key
then press ENTER
now you change the values with + and - key
finaly pres ENTER again.

MenuEnty             waht it do
========             ==========
return               retuns to textinput Dispaly
Speed                set the morsing speed (dits per second)
let pin high         pull the pin up between the symbols
Bk.L.britness        set the backlight britness
clear message...     select whether the message will be deleted after transmition
                     (please press 2 tims ENTER)(this will set the ClMgATr value)
about                print an about message

*/
PS2Keyboard keyboard;

int cyy=75;                                 //time for one 'dit' (.) in ms (defaultsetting)
const byte pin=2;                           //output pin
boolean letPinOn =true;                     //pin is HIGH betwin 'dits' and 'dahs'
const int fre = 1000;                       //tonefrequensy
LiquidCrystal lcd(12, 11, 7, 6, 5, 4);      //lcd pins
const int DataPin = 8;                      //datapin from keyboard (clockpin 3?)
const int IRQpin =  5;                      //IRQPin (from keyboard?)
const byte backlight=10;                    //pin for lcdBacklight
byte blight=200;                            //lcdBacklight britness
boolean ClMgATr=true;                       //clear message after transmitting?

//variables for programm (don't edit that if you don't know what you're doing)

char text[33]= "                               "; 
byte cur=0;                                       
byte menuselect=0;
char keb = ' ';
int dit=cyy;
int dah=3*cyy;
int p=cyy;
int pau=2*cyy;
int lpau=6*cyy;
byte fo=0;

//programm  (don't edit that if you don't know what you're doing)
//===================================================================================================================

void setup(){                      //=======this is doing on startup

  pinMode(backlight,OUTPUT);           //initialize backlight-pin
  analogWrite(backlight, blight);      //set backlight to default britness
  settimme();                          //set the time values for morsing
  keyboard.begin(DataPin, IRQpin);     //initialize keyboard
  lcd.begin(16, 2);                    //initialize lcd
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Ardumors");               //print welcome message to lcd
  lcd.setCursor(0,1);
  lcd.print("Version 0.00");
  delay(1500);                         //wait 1.5 seconds
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("type and press");         //print message "type and press Enter to mors"
  lcd.setCursor(0,1);
  lcd.print("Enter to mors");
  while(!(keyboard.available())){      //wait until a key pressed
  }
  lcd.clear();
  lcd.cursor();

}

void loop(){                    //===========this is doning while runnig
  while(keyboard.available()){        //read keys while keyboard available
    keb=keyboard.read();

    switch(keb){                      
    case PS2_DELETE:                  //on delete is pressed
      del();                            //call sub delete (to delete the actualy letter)
      break;
    case PS2_ENTER:                   //on ENTER is pressed
      lcd.noCursor();
      transmitt();                      //call sub transmitt (to transmitt the message)
      if(ClMgATr){                      //delete message if ClMgATr value is set
        cur=0;
        lcd.clear();
      }
      break;
    case PS2_UPARROW:                 //on arrow up key is pressed
                                           //go to menu
      lcd.noCursor();
      menu();
      break;



    default:                          //all other keys will printet in your messeage
      editt();
      break;

    }
  }
}


void menu(){                      //=======this ist the sub for the menu

  const byte HowManyMenuEntrys = 5;    //So many entries has the menu. 

  menuselect=0;
  char kread=keyboard.read();
  while(!(kread==PS2_ENTER)){          //stay in menu until enter will pressed

    switch(kread){
    case PS2_UPARROW:                  //on arrow up is pressed go up in menu
      if(menuselect<HowManyMenuEntrys){  //do this only if the last menuenty is'nt selectet
        menuselect++;

      }

      break;  
    case PS2_DOWNARROW:                //this is the same for arrow down
      if(menuselect>0){
        menuselect--;
       
      }
      break;
    }
    displayMenuItem();                 //finaly display menu entry
    while(!(keyboard.available())){    //ant then wait until any key is pressed
    }
    kread=keyboard.read();
  }
  menuEnter();                         //if enter pressed: run the entry
  reDisplayy();
}


void displayMenuItem(){          //========display the selectet menu item
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("===MENU===");
  lcd.setCursor(0,1);
  switch(menuselect){
  case 0:
    lcd.print("return");
    break;
  case 1:
    lcd.print("Speed");
    break;
  case 2:
    lcd.print("let pin High");
    break;
  case 3:
    lcd.print("Bk.L. britness");   
    break;
  case 4:
    lcd.print("clear message...");
    break;
  case 5:
    lcd.print("about");
    break;
  default:
    lcd.print("noEnty");
    break;
  }
}

void menuEnter(){                   //======run the selectet item
  switch(menuselect){
  case 1:
    speeed();
    break;
  case 2:
    enableLetPinOn();
    break;
  case 3:
    BkLightBrit();
    break;
  case 4:
    clrmsg();
    break;
  case 5:
    abou();
    break;
  }
}

//========================================================================menuitms

void speeed(){                          //======set the morsing speed
  lcd.clear();
  lcd.print("+    Speed     -"); 
  char kread=keyboard.read();
  byte trash = 1000/cyy;                    //the speed is 1/time for one dit * 1000miliseconds
  lcd.setCursor(0,1);
  lcd.print("   ");
  lcd.print(trash);
  lcd.print("/sec");
  while(!(kread==PS2_ENTER)){               //stay in this settin point until enter is pressed
    switch(kread){
    case '+':                                  //if "+" pressed increase the speed
      trash++;
      lcd.setCursor(0,1);
      lcd.print("   ");
      lcd.print(trash);
      lcd.print("/sec    "); 
      break;
    case '-':                                  //on "-" decrease it
      trash--;
      lcd.setCursor(0,1);
      lcd.print("   ");
      lcd.print(trash);
      lcd.print("/sec    "); 
      break;
    }
    kread=keyboard.read();                      //read the next key
  }
  cyy=1000/trash;                             //finely calculate it back and
  settimme();                                 //convert it to the time values
}

void enableLetPinOn(){                     //======Set whether the pin should remain off or on between morsetons 
  lcd.clear();
  lcd.print("-let Pin High +");
  lcd.setCursor(0,1);
  lcd.print("   ");                          
  if(letPinOn){                            
    lcd.print("true");                        //prints the statement of the value
  }
  else{
    lcd.print("false");
  }
  char kread=keyboard.read();
  while(!(kread==PS2_ENTER)){
    switch(kread){
    case '+':                                 //this works like above but the value is true ore false
      letPinOn=true;
      lcd.setCursor(3,1);
      lcd.print("true   ");
      digitalWrite(pin, HIGH);
      break;
    case '-':
      letPinOn=false;
      lcd.setCursor(3,1);
      lcd.print("false   ");
      digitalWrite(pin,LOW);
      break;
    }
    kread=keyboard.read();
  }

}

void BkLightBrit(){                        //======set backlightBritness
  lcd.clear();
  lcd.print("+   britness   -");
  lcd.setCursor(3,1);
  lcd.print(blight);
  lcd.print("/255");
  char kread=keyboard.read();
  while(!(kread==PS2_ENTER)){
    switch(kread){
    case '+':
      if(blight<245){
        blight=blight+10;
      }
      analogWrite(backlight,blight);
      lcd.setCursor(3,1);
      lcd.print(blight);
      lcd.print("/255   ");
      break;
    case '-':
      if(blight>=10){
        blight=blight-10;
        analogWrite(backlight,blight);
      }
      lcd.setCursor(3,1);
      lcd.print(blight);
      lcd.print("/255   ");
      break;
    }
    kread=keyboard.read();
  }

}

void clrmsg(){                          //=======set whether the typed text will be cleared after transmitting
  lcd.clear();
  lcd.print("clear message");
  lcd.setCursor(0,1);
  lcd.print("after transmitt");
  while(!(keyboard.available())){
  }
  char kread=keyboard.read();
  if(kread==PS2_ENTER){
    lcd.clear();
    lcd.print("-clear message +");
    lcd.setCursor(3,1);
    if(ClMgATr){
      lcd.print("true");
    }
    else{
      lcd.print("false");
    }
    kread=keyboard.read();
    while(!(kread==PS2_ENTER)){
      switch(kread){
      case '+':
        ClMgATr=true;
        lcd.setCursor(3,1);
        lcd.print("true");
        break;
      case'-':
        ClMgATr=false;
        lcd.setCursor(3,1);
        lcd.print("false");
        break;
      }
      kread=keyboard.read();
    }
  }
}

void abou(){                              //======print an about message
  lcd.clear();
  lcd.print("Ardumors by");
  lcd.setCursor(0,1);
  lcd.print("Markus Klingler");
  while(!(keyboard.read()==PS2_ENTER)){
  }
  lcd.clear();
  lcd.print("Website: kuskus");
  lcd.setCursor(0,1);
  lcd.print(".bplaced.net");
  while(!(keyboard.read()==PS2_ENTER)){
  }
}
//============================================================================
void reDisplayy(){                 //======this funktion will be used to redisplay the typed text (when you cames from menu or the transmission finished)
  lcd.clear();
  for(int x=0;x<cur;x++){            //print all characters from 0 to the current position on the text
    if(x==16){
      lcd.setCursor(0,1);
    }
    lcd.print(text[x]);

  }
  lcd.cursor();
}

void editt(){                      //======this funktion will be called when normel key is pressed
  
  text[cur]=keb;
  lcd.print(keb);
  if(cur<32){ 
    cur++;                          //increase the current position on the text value
  }
  if(cur==16){                        //if the char on a position bigger then 16 print it to second line
    lcd.setCursor(0,1);
  }


}


void del(){                    //======this will be called on Delete is pressing
  if(cur>0){
    cur--;                      //decrease position on text and
  }
                                //erase the character from the screen (the char in value will be overwrite by editting)
  if(cur<16){
    lcd.setCursor(cur,0);
    lcd.print(' ');

    lcd.setCursor(cur,0);
  }
  else{
    lcd.setCursor((cur-16),1);
    lcd.print(' ');

    lcd.setCursor((cur-16),1);
  }
  // }      


}

void transmitt(){                 //=======this will be trasmitting the text

  lcd.clear();
  lcd.noCursor();
  lcd.setCursor(0,0);
  lcd.print("Transmitting   %");

  for(byte x=0;x<cur;x++){            //mors it to current position on text
    char aa=text[x];

    lcd.setCursor(0,1);                //it mors it and print an output on screen
    mors(aa);
    lcd.setCursor(0,1);
    lcd.print("               ");
    fo=(x*100)/cur;
    lcd.setCursor(14,0);
    if(fo>9){
      lcd.setCursor(13,0);
    }
    lcd.print(fo);

    if(keyboard.read()==PS2_ESC){      //if escape (ESC) pressed aport transmission
      lcd.setCursor(0,1);
      lcd.print("aported     ");
      delay(500);
      x=101;
    }
  }

  lcd.cursor();
  reDisplayy();                      //finelay reprint the display

}



void mors(char letter){              //======this will mors the characters and print an output
                                     //======i think about it's better then develope a libary for it
  lcd.print(letter);
  lcd.print(" ");
  switch (letter){
  case 'a':
    didd();                                //call sub for a '.'
    dahh();                                //call sub for a '-'
    delay(pau);
    break;
  case 'b':
    dahh();                                 //do the same for the other characters
    didd();
    didd();
    didd();
    delay(pau);
    break;
  case 'c':
    dahh();
    didd();
    dahh();
    didd();
    delay(pau);
    break;
  case 'd':
    dahh();
    didd();
    didd();
    delay(pau);
    break;
  case 'e':
    didd();
    delay(pau);
    break;
  case 'f':
    didd();
    didd();
    dahh();
    didd();
    delay(pau);
    break;
  case 'g':
    dahh();
    dahh();
    didd();
    delay(pau);
    break;
  case 'h':
    didd();
    didd();
    didd();
    didd();
    delay(pau);
    break;
  case 'i':
    didd();
    didd();
    delay(pau);
    break;
  case 'j':
    didd();
    dahh();
    dahh();
    dahh();
    delay(pau);
    break;
  case 'k':
    dahh();
    didd();
    dahh();
    delay(pau);
    break;
  case 'l':
    didd();
    dahh();
    didd();
    didd();
    delay(pau);
    break;
  case 'm':
    dahh();
    dahh();
    delay(pau);
    break;
  case 'n':
    dahh();
    didd();
    delay(pau);
    break;
  case 'o':
    dahh();
    dahh();
    dahh();
    delay(pau);
    break;
  case 'p':
    didd();
    dahh();
    dahh();
    didd();
    delay(pau);
    break;
  case 'q':
    dahh();
    dahh();
    didd();
    dahh();
    delay(pau);
    break;
  case 'r':
    didd();
    dahh();
    didd();
    delay(pau);
    break;
  case 's':
    didd();
    didd();
    didd();
    delay(pau);
    break;
  case 't':
    dahh();
    delay(pau);
    break;
  case 'u':
    didd();
    didd();
    dahh();
    delay(pau);
    break;
  case 'v':
    didd();
    didd();
    didd();
    dahh();
    delay(pau);
    break;
  case 'w':
    didd();
    dahh();
    dahh();
    delay(pau);
    break;
  case 'x':
    dahh();
    didd();
    didd();
    dahh();
    delay(pau);
    break;
  case 'y':
    dahh();
    didd();
    dahh();
    dahh();
    delay(pau);
    break;
  case 'z':
    dahh();
    dahh();
    didd();
    didd();
    delay(pau);
    break;
  case ' ':
    delay(lpau);
    break;
  case 'K': //KA
    dahh();
    didd();
    dahh();
    didd();
    dahh();
    delay(pau);
    break;
  case 'S': //SK
    didd();
    didd();
    didd();
    dahh();
    didd();
    dahh();
    delay(pau);
    break;
  }
  switch (letter){
  case '0':
    dahh();
    dahh();
    dahh();
    dahh();
    dahh();
    delay(pau);
    break;
  case '1':
    didd();
    dahh();
    dahh();
    dahh();
    dahh();
    delay(pau);
    break;
  case '2':
    didd();
    didd();
    dahh();
    dahh();
    dahh();
    delay(pau);
    break;
  case '3':
    didd();
    didd();
    didd();
    dahh();
    dahh();
    delay(pau);
    break;
  case '4':
    didd();
    didd();
    didd();
    didd();
    dahh();
    delay(pau);
    break;
  case '5':
    didd();
    didd();
    didd();
    didd();
    didd();
    delay(pau);
    break;
  case'6':
    dahh();
    didd();
    didd();
    didd();
    didd();
    delay(pau);
    break;
  case '7':
    dahh();
    dahh();
    didd();
    didd();
    didd();
    delay(pau);
    break;
  case '8':
    dahh();
    dahh();
    dahh();
    didd();
    didd();
    delay(pau);
    break;
  case '9':
    dahh();
    dahh();
    dahh();
    dahh();
    didd();
    delay(pau);
    break;
  case '-':
    dahh();
    didd();
    didd();
    didd();
    didd();
    dahh();
    delay(pau);
    break;
  case '.':
    didd();
    dahh();
    didd();
    dahh();
    didd();
    dahh();

    delay(pau);
    break;
  case 'A': //AR
    didd();
    dahh();
    didd();
    dahh();
    didd();
    delay(pau);
    break;
  case '/':
    dahh();
    didd();
    didd();
    dahh();
    didd();
    delay(pau);
    break;
  case '=':
    dahh();
    didd();
    didd();
    didd();
    dahh();
    delay(pau);
    break;
  case '+':
    didd();
    dahh();
    didd();
    dahh();
    didd();
    delay(pau);
    break;
  case '?':
    didd();
    didd();
    dahh();
    dahh();
    didd();
    didd();
    delay(pau);
    break;
  case ':':
    dahh();
    dahh();
    dahh();
    didd();
    didd();
    didd();
    delay(pau);
    break;
  }
  switch (letter){
  case 'T':
    didd();
    break;
  case 'H':
    dahh();
    break;
  case 'B':
    delay(pau);
    break;
  }

}

void didd(){                    //=====this is sub for '.'
  lcd.print(".");                  //print '.' to lcd
  tone(pin,fre);                   //and make a tone on pin
  delay(dit);
  noTone(pin);
  if(letPinOn){
    digitalWrite(pin,HIGH);
  }
  delay(p);
}
void dahh(){                   //======this is sub for '-'
  lcd.print("-");                //the same for '-'
  tone(pin,fre);
  delay(dah);
  noTone(pin);
  if(letPinOn){
    digitalWrite(pin,HIGH);
  }
  delay(p);
}

void settimme(){                //======this will set the time varables for CW

  dit=cyy;
  dah=3*cyy;
  p=cyy;
  pau=2*cyy;
  lpau=6*cyy;

}







